Package: interactiveDisplayBase
Type: Package
Title: Base package for enabling powerful shiny web displays of
        Bioconductor objects
Version: 1.44.0
Date: 2021-07-30
Authors@R: c(
    person("Bioconductor Package", "Maintainer", email="maintainer@bioconductor.org",
             role="cre"),
    person("Shawn", "Balcome", role = c("aut"),
        email = "balc0022@umn.edu"),
    person("Marc", "Carlson", role = "ctb"),
    person("Marcel", "Ramos", role = "ctb")
  )
Imports: shiny, DT
Depends: R (>= 2.10), methods, BiocGenerics
Suggests: knitr, markdown
Enhances: rstudioapi
Description: The interactiveDisplayBase package contains the the basic
        methods needed to generate interactive Shiny based display
        methods for Bioconductor objects.
License: Artistic-2.0
Collate: interactiveDisplayBase.R dataframe.R dot_runApp.R zzz.R
VignetteBuilder: knitr
biocViews: GO, GeneExpression, Microarray, Sequencing, Classification,
        Network, QualityControl, Visualization, Visualization,
        Genetics, DataRepresentation, GUI, AnnotationData, ShinyApps
RoxygenNote: 7.1.1
git_url: https://git.bioconductor.org/packages/interactiveDisplayBase
git_branch: RELEASE_3_20
git_last_commit: 2262e91
git_last_commit_date: 2024-10-29
Repository: Bioconductor 3.20
Date/Publication: 2024-10-29
NeedsCompilation: no
Packaged: 2024-10-30 01:15:06 UTC; biocbuild
Author: Bioconductor Package Maintainer [cre],
  Shawn Balcome [aut],
  Marc Carlson [ctb],
  Marcel Ramos [ctb]
Maintainer: Bioconductor Package Maintainer <maintainer@bioconductor.org>

.onLoad <- function(libname, pkgname)
{
    suppressMessages({
        addResourcePath("js-interactiveDisplayBase", system.file("www", "js", package="interactiveDisplayBase"))
        addResourcePath("css-interactiveDisplayBase", system.file("www", "css", package="interactiveDisplayBase"))
    })
}

.runApp <- function(app, ...) {  
    ## selectively use the RStudio viewer pane (if available)
    viewer <- getOption("viewer")
    if (!is.null(viewer) && is.function(viewer)) {
        runApp(app, launch.browser = viewer, ...)
    } else {
        runApp(app, ...)
    }
}

## ----setup, echo=FALSE--------------------------------------------------------
suppressWarnings(suppressPackageStartupMessages(library(knitr)))
options(width=80)

## ----wrap-hook, echo=FALSE----------------------------------------------------
hook_output = knit_hooks$get('output')
knit_hooks$set(output = function(x, options) {
  # this hook is used only when the linewidth option is not NULL
  if (!is.null(n <- options$linewidth)) {
    x = knitr:::split_lines(x)
    # any lines wider than n should be wrapped
    if (any(nchar(x) > n)) x = strwrap(x, width = n)
    x = paste(x, collapse = '\n')
  }
  hook_output(x, options)
})

## ----interactiveDisplayBase-load,include=TRUE,results="hide",message=FALSE,warning=FALSE----
library(interactiveDisplayBase)

## ----dataframe_demo, eval=FALSE-----------------------------------------------
#  mtcars2 <- display(mtcars)

################################################################################
###   Main
################################################################################

## declare the display generic
setGeneric("display", function(object, ...)
  standardGeneric("display")
)

setMethod("display",
signature(object = "ANY"),
function(object){
  message("Wrong object")
})

setMethod("display",
signature(object = "missing"),
function(object){
  message("Missing object")
})

##########################################################################3
## experimental new(er) version of .dataFrame
## helper for rowname wrangling:
.rownamesAreUnique <- function(df) {
    identical(
        length(rownames(df)),
        length(unique(rownames(df)))
    )
}

.dataFrame3 <- function(
    df, ..., summaryMessage = "", serverOptions = list(orderClasses = TRUE)
) {
    rowNames <- rownames(df)
    ## If the rownames are unique then just use the names as idx.
    ## but if not, then also also append supplementary idx
    if (.rownamesAreUnique(df)) {
        dt <- data.frame(idx = rowNames, df)
    } else {
        dt <- data.frame(idx = seq_len(nrow(df)), rownames = rowNames, df)
    }

    ## define the app
    app <- list(
        ui = fluidPage(
            titlePanel("Select rows in the Data Table"),
            sidebarLayout(
                sidebarPanel(
                    actionButton("btnSend", "Send"),
                    width = 1
                ),
                mainPanel(
                    DT::dataTableOutput('tbl')
                )
            )
        ),
        server = function(input, output) {
            output$tbl <- DT::renderDataTable(
                df, server = TRUE, filter = "top",
                options = serverOptions
            )

            if (length(summaryMessage) != 1L) {
                output$summary <- renderUI({
                    HTML(paste0(
                        sprintf(
                            '<span class="shiny-html-output" >%s</span> ',
                            summaryMessage
                        ), "<br>"
                    ))
                })
            }

            observe({
                if (input$btnSend > 0)
                    isolate({
                        idx <- input$tbl_rows_selected
                        stopApp(returnValue = df[idx,])
                    })
            })
        }
    )

    .runApp(app, ...)

}

setMethod("display", signature(object = "data.frame"),
    function(object, ...) {
        .dataFrame3(df=object, ...)
    }
)

\docType{methods}
\name{display}
\alias{display}
\alias{display,ANY-method}
\alias{display,missing-method}
\alias{display,data.frame-method}

\title{display: Open a Shiny application for a Bioconductor object}
\description{
  This opens a shiny visualization application in the browser
  based on the submitted object.
}
\usage{
display(object, ...)
}
\arguments{
  \item{object}{data object to display}
  \item{...}{additional arguments passed to methods; currently unused.}
}
\value{
  Usually some variation of the initial input object, but it may be
  altered by the display widget (subset for example).
}
\seealso{
  \url{http://bioconductor.org/packages/2.13/bioc/html/interactiveDisplayBase.html}
}
\author{Shawn Balcome and Marc Carlson}
\examples{

if(interactive()) {

## draw a data.frame
display(mtcars)

## subset a data.frame:
mtcars2 <- display(mtcars)

}

}

\keyword{methods}

\docType{methods}
\name{.runApp}
\alias{.runApp}

\title{Run a shiny app, capturing results to the R session}
\description{
  This utility function launches a shiny visualization application,
  either in the RStudio viewer pane (if run under RStudio) or in the
  browser.
}
\usage{
.runApp(app, ...)
}
\arguments{
  \item{app}{The shiny application definition, see \code{?shiny::runApp}.}
  \item{...}{additional arguments passed to \code{shiny::runApp()}.}
}
\value{
  The return value of \code{shiny::runApp}.
}
\author{Martin Morgan}
\examples{

if (interactive()) {
    require(shiny)

    app <- list(
        ui = fluidPage(
          title="Who Am I?",
          sidebarLayout(
              position="left",
              sidebarPanel(
                  h1("Your name"),
                  textInput("your_name", "Your name?", "Anonymous"),
                  actionButton("done", "Done")),
              mainPanel(
                  "Hi", textOutput("your_name", inline=TRUE))
              )),

        server = function(input, output) {
            output$your_name <- renderText(input$your_name)
            observe({
                if (input$done > 0)
                    isolate(stopApp(returnValue = input$your_name))
            })

        })

    .runApp(app)
}
}

\keyword{manip, internal}
